<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "salesforce_entity_mapping".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SalesforceEntityMapping".
 *
 * Columns in table "salesforce_entity_mapping" available as properties of the model,
 * followed by relations of table "salesforce_entity_mapping" available as properties of the model.
 *
 * @property integer $id
 * @property string $entity_table
 * @property integer $entity_id
 * @property integer $salesforce_entity_id
 *
 * @property SalesforceEntity $salesforceEntity
 */
abstract class BaseSalesforceEntityMapping extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'salesforce_entity_mapping';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SalesforceEntityMapping|SalesforceEntityMappings', $n);
    }

    public static function representingColumn()
    {
        return 'entity_table';
    }

    public function rules()
    {
        return array(
            array('entity_id, salesforce_entity_id', 'numerical', 'integerOnly'=>true),
            array('entity_table', 'length', 'max'=>100),
            array('entity_table, entity_id, salesforce_entity_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, entity_table, entity_id, salesforce_entity_id', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'salesforceEntity' => array(self::BELONGS_TO, 'SalesforceEntity', 'salesforce_entity_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'entity_table' => Yii::t('app', 'Entity Table'),
            'entity_id' => Yii::t('app', 'Entity'),
            'salesforce_entity_id' => null,
            'salesforceEntity' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('entity_table', $this->entity_table, true);
        $criteria->compare('entity_id', $this->entity_id);
        $criteria->compare('salesforce_entity_id', $this->salesforce_entity_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
